unit Un_23_1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  List: TStringList; //  .

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  List:=TStringList.Create; // .
end;

//     .
procedure TForm1.Button1Click(Sender: TObject);
begin
   List.Append(Edit1.Text); //   .
   Edit1.Text:=''; // .
   Edit1.SetFocus; // .
end;

//    TMemo.
procedure TForm1.Button2Click(Sender: TObject);
var
  k: Integer;
begin
   Memo1.Lines.Clear; // TMemo.
   for k:=0 to List.Count-1 do
     Memo1.Lines.Add(List.Strings[k]);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   Edit1.SetFocus; // .
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   List.Free; // .
end;

//    .
procedure TForm1.Button3Click(Sender: TObject);
var
  Index: Integer;
begin
  if List.Find(Edit1.Text, Index) Then //  .
     Label3.Caption:=' '+IntToStr(Index)
  else // .
     Label3.Caption:='   !!!';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    List.Sort; // .
end;

end.
